var bomHeaderSelectedIndex = 0;

$(document).ready(function () {
    
    $('#bomHeaderTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "quantity" },
            { "data": "uom" },
            { "data": "description" },
            // { "data": "status"},
            // { "data": "action" },
            { "data": "status", className: "status" },
            { "data": "action", className: "action" },


        ],
        columnDefs: [
            { width: 100, targets: 1 },
            { width: 100, targets: 2 },
            { width: 100, targets: 3 }
        ],
    });
    $('#bomDataTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "product_name" },
            { "data": "quantity" },
            { "data": "uom" },
            { "data": "tolerance" },
            { "data": "status" },
            { "data": "action" },

        ],
        columnDefs: [
            { width: 100, targets: 1 },
            { width: 100, targets: 2 },
            { width: 150, targets: 3 },
        ],
    });

    getBomHeader(1);

    //Reset form
    $('#btnCancelAddBomHeader').on('click', function () {
        $('#BomHeaderForm').trigger("reset");
        $('#addbomHeaderModal').modal('toggle');
        $('#btnSaveAddBomHeader').show();
        $('#btnSaveAddBomHeader').text("Save");

    });


    $('#btnCancelAddBomData').on('click', function () {
        $('#BomDataForm').trigger("reset");
        $('#addbomDataModal').modal('toggle');
        $('#btnSaveAddBomData').show();
        $('#btnSaveAddBomData').text("Save");

    });


    /*$('#bomHeaderTable').DataTable({

    });

    $('#bomDataTable').DataTable({
   
    });*/


    //Ajax call for Auto complete product Name Field.
    $.ajax({
        type: 'GET',
        url: '/pp/bomHeader/searchPName',
        success: function (response) {
            console.log(response);
            if (response) {
                $("#txtProductName").setData(response);
            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });


    //Ajax call for Auto complete Material product Name Field.
    $.ajax({
        type: 'GET',
        url: '/pp/bomData/searchPDName',
        success: function (response) {
            console.log(response);
            if (response) {
                $("#txtProductName2").setData(response);
            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });



    /**
      * Save add bill of material
      * This function is used to save header order data.
      */
    $('#btnSaveAddBomHeader').click(function (event) {
        event.preventDefault();
        var form = $('#BomHeaderForm').get(0);
        console.log(form);
        var data = new FormData(form);

        if ($('#btnSaveAddBomHeader').text() == "Save") {
            save(data);
            getBomHeader(1);
            $('#addbomHeaderModal').modal('toggle');

        } else if ($('#btnSaveAddBomHeader').text() == "Update") {
            updateBomHeader(data);
            getBomHeader(1);
            $('#addbomHeaderModal').modal('toggle');


        }

    });


    //load edit bill of material
    $('#bomHeaderTable tbody').on('click', '.btn-edit', function (event) {
        event.preventDefault();
        var table = $('#bomHeaderTable').DataTable();
        console.log($(this).parents('tr').index());
        var rowData = table.row($(this).parents('tr').index()).data();
        console.log(rowData);

        $('#addbomHeaderModal').modal('show');
        $('#hidBomID').val(rowData.pp_bom_header_id);


        $.ajax({
            type: "GET",
            url: "/pp/bomHeader/bomHeader/" + rowData.pp_bom_header_id,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);

                $('#exampleModalLabel').html("Edit Bill Of Material");
                $('#btnSaveAddBomHeader').text("Update");
                var product_id = response.data.result['BomHeader']['product_id'];
                var product_name = response.data.result['BomHeader']['product_name'];
                var quantity = response.data.result['BomHeader']['quantity'];
                var uom = response.data.result['BomHeader']['uom'];
                var description = response.data.result['BomHeader']['description'];



                $('#txtProductID').val(product_id);
                $('#txtProductName').val(product_name);
                $('#txtQuantity').val(quantity);
                $('#txtuom').val(uom);
                $('#txtDescription').val(description);


                $('#addbomHeaderModal').modal('show');


            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });



    });

    //load view bill of material
    $('#bomHeaderTable tbody').on('click', '.btn-view', function (event) {
        event.preventDefault();
        var table = $('#bomHeaderTable').DataTable();
        console.log($(this).parents('tr').index());
        var rowData = table.row($(this).parents('tr').index()).data();
        console.log(rowData);

        $('#addbomHeaderModal').modal('show');

        $.ajax({
            type: "GET",
            url: "/pp/bomHeader/bomHeader/" + rowData.pp_bom_header_id,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);

                $('#exampleModalLabel').html("Bill Of Material");
                $('#btnSaveAddBomHeader').hide();
                var product_id = response.data.result['BomHeader']['product_id'];
                var product_name = response.data.result['BomHeader']['product_name'];
                var quantity = response.data.result['BomHeader']['quantity'];
                var uom = response.data.result['BomHeader']['uom'];
                var description = response.data.result['BomHeader']['description'];



                $('#txtProductID').val(product_id);
                $('#txtProductName').val(product_name);
                $('#txtQuantity').val(quantity);
                $('#txtuom').val(uom);
                $('#txtDescription').val(description);


            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });

    });


    // //Select table row
    $('#bomHeaderTable tbody ').on('click', 'tr', function () {
        var table = $('#bomHeaderTable').DataTable();
        var rowData = table.row($(this).index()).data();
        bomHeaderSelectedIndex = $(this).index();
        getBomData(rowData.pp_bom_header_id);
        $('#txtBomHeaderId').val(rowData.pp_bom_header_id);
        // $('#txtProductID2').val(rowData.product_id);
        // $('#txtProductName2').val(rowData.product_name);
        //$('#txtQuantity2').val(rowData.quantity);
        //$('#txtUom2').val(rowData.uom);
        $('#hidBomDataID').val(rowData.pp_bom_header_id);

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');

            getBomData(rowData.pp_bom_header_id);

        }
        else {
            table.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

        }

    });



    /**
      * Save bill of material data
      * This function is used to save bill of material data.
      */

    $('#btnSaveAddBomData').click(function (event) {
        event.preventDefault();
        var form = $('#BomDataForm').get(0);
        var data = new FormData(form);
        var table = $('#bomHeaderTable').DataTable();
        var rowData = table.row(bomHeaderSelectedIndex).data();

        if ($('#btnSaveAddBomData').text() == "Save") {
            saveData(data);
            getBomData(rowData.pp_bom_header_id);
            $('#addbomDataModal').modal('toggle');

        } else if ($('#btnSaveAddBomData').text() == "Update") {
            updateBomData(data);
            getBomData(rowData.pp_bom_header_id);
            $('#addbomDataModal').modal('toggle');
        }


    });



    //load edit bill of material data
    $('#bomDataTable tbody').on('click', '.btn-edit', function (event) {
        event.preventDefault();
        var table = $('#bomDataTable').DataTable();
        console.log($(this).parents('tr').index());
        var rowData = table.row($(this).parents('tr').index()).data();
        console.log(rowData);

        $('#addbomDataModal').modal('show');
        $('#hidBomDataID').val(rowData.pp_bom_plan_data_id);



        $.ajax({
            type: "GET",
            url: "/pp/bomData/bomData/" + rowData.pp_bom_plan_data_id,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);

                $('#exampleModalLabel1').html("Bill of Material Data");
                $('#btnSaveAddBomData').text("Update");
                var pp_bom_header_id = response.data.result['bomData']['pp_bom_header_id'];
                var product_id = response.data.result['bomData']['product_id'];
                var product_name = response.data.result['bomData']['product_name'];
                var quantity = response.data.result['bomData']['quantity'];
                var uom = response.data.result['bomData']['uom'];
                var tolerance = response.data.result['bomData']['tolerance'];

                $('#txtBomHeaderId').val(pp_bom_header_id);
                $('#txtProductID2').val(product_id);
                $('#txtProductName2').val(product_name);
                $('#txtQuantity2').val(quantity);
                $('#txtUom2').val(uom);
                $('#txtTolerance').val(tolerance);

                $('#addbomDataModal').modal('show');


            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });



    });


    //load view bill of material data
    $('#bomDataTable tbody').on('click', '.btn-view', function (event) {
        event.preventDefault();
        var table = $('#bomDataTable').DataTable();
        console.log($(this).parents('tr').index());
        var rowData = table.row($(this).parents('tr').index()).data();
        $('#addbomDataModal').modal('show');


        $.ajax({
            type: "GET",
            url: "/pp/bomData/bomData/" + rowData.pp_bom_plan_data_id,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);
                $('#exampleModalLabel1').html("Bill of Material Data");
                $('#btnSaveAddBomData').hide();
                var pp_bom_header_id = response.data.result['bomData']['pp_bom_header_id'];
                var product_id = response.data.result['bomData']['product_id'];
                var product_name = response.data.result['bomData']['product_name'];
                var quantity = response.data.result['bomData']['quantity'];
                var uom = response.data.result['bomData']['uom'];
                var tolerance = response.data.result['bomData']['tolerance'];

                $('#txtBomHeaderId').val(pp_bom_header_id);
                $('#txtProductID2').val(product_id);
                $('#txtProductName2').val(product_name);
                $('#txtQuantity2').val(quantity);
                $('#txtUom2').val(uom);
                $('#txtTolerance').val(tolerance);

                $('#addbomDataModal').modal('show');

            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });



    });





});


function showModelAddBOMHeader() {
    $('#addbomHeaderModal').modal('toggle');
}

function showModelAddbomData() {
    $('#addbomDataModal').modal('toggle');
}
/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}


/**
* getPName
* Function for Auto Complete to fill other fields by enter the Name Field.
*/
function getProductName() {
    $.ajax({
        type: 'GET',
        url: '/pp/bomHeader/getPName/' + $('#txtProductName').optionID(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response) {
                $('#txtProductID').val(response.product_id);
                $('#txtuom').val(response.uom_id);

            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
        }
    });

}


/**
* getPDName
* Function for Auto Complete to fill other fields by enter the Name Field.
*/
function getMaterialName() {
    $.ajax({
        type: 'GET',
        url: '/pp/bomData/getPDName/' + $('#txtProductName2').optionID(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response) {
                $('#txtProductID2').val(response.product_id);
                $('#txtUom2').val(response.uom_id);

            } else {
                showErrorMessage();
            }
        },
        error: function (data) {
            showErrorMessage();
            console.log(data);
        },
        complete: function () {
        }
    });

}


/**
* save
* This function is used to save bill of material.
* @param dara This is the paramter to ajax data
*/
function save(data) {

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/bomHeader',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {



                showSuccessMessage("Bill of material details have been saved successfully...");

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomHeaderForm').trigger("reset");
        }

    });
}

/**
* getBomHeader
* This function is used to get bill of material to the list view.
* This is the paramter to ajax data
*/
function getBomHeader(page_id) {

    var disable = { 0: "", 1: "checked" }
    $.ajax({
        type: "GET",
        url: "/pp/bomHeader/allbomHeader",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['pp_bom_header_id'];
                    var product_id = response.data.result[i]['product_id'];
                    var product_name = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var uom = response.data.result[i]['uom'];
                    var description = response.data.result[i]['description'];
                    var string_id = "'" + id + "'";
                    data.push({
                        "pp_bom_header_id": id,
                        "product_id": product_id,
                        "product_name": product_name,
                        "quantity": quantity,
                        "uom": uom,
                        "description": description,
                        "status": '<label class="switch ml-4"><input type="checkbox" id="' + response.data.result[i].pp_bom_header_id + '" onchange="disable(event, ' + "'BomHeader'" + ')" ' + disable[response.data.result[i].status] + '><span class="slider round"></span</lable>',
                        "action": '<button class="btn btn-warning mr-4 ml-2 btn-edit" data-toggle="modal" data-target="#addOrderModal"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button><button class="btn btn-success mr-4 btn-view" data-toggle="modal" data-target="#addOrderModal"><i class="fa fa-eye" aria-hidden="true"></i></button><button class="btn btn-danger" onclick="_delete(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',

                    });
                }


                var table = $('#bomHeaderTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}

/**
* delete
* This function is used to delete bill of material.
*/

function _delete(id) {
    $.ajax({
        type: 'DELETE',
        url: '/pp/bomHeader/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage("Bill of material has been deleted successfully...")
                getBomHeader(1);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}

/**
* updateBomHeader
* This function is used to update bill of material.
* @param data This is the paramter to ajax data
*/
function updateBomHeader(data) {
    console.log(data);
    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/bomHeader/update',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Bill of material record has been updated successfully...");

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomHeaderForm').trigger("reset");
            $('#btnSaveAddBomHeader').text("Save");
        }

    });
}


/**
* disabled
* This function is used to update settings in bill of material header.
* @param url This is the paramter to ajax request url
* @param id This is the paramter to ajax data
*/
function _disabled(id, status) {

    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: 'DELETE',
        url: '/pp/bomHeader/bomHeader/' + id,
        data: {
            _token: $('input[name=_token]').val(),
            "status": bool
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                if (status) showSuccessMessage("Data has been enabled successfully...");
                if (!status) showSuccessMessage("Data has been disabled successfully...");



            } else {
                var msg = response.data.message;
                var id = response.data.result;

                if (msg == "assigned") {
                    //assigned settings cannot be disabled
                    showWarningMessage("Settings has been assigned...!");

                } else if (msg == "error") {
                    showErrorMessage();
                }
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}



/**
* save
* This function is used to disable settings in bill of material.
* @param event This is the paramter to identifi desable/enable
*/
function disable(event) {
    var id = event.target.id;
    var status = event.target.checked;
    _disabled(id, status);
}



/**
* saveData
* This function is used to save bill of material data.
* @param dara This is the paramter to ajax data
*/
function saveData(data) {

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/bomData',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Bill of material data details have been saved successfully...");


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomDataForm').trigger("reset");
        }

    });
}


/**
* getBomData
* This function is used to get bill of material data to the list view.
* This is the paramter to ajax data
*/
function getBomData(order_id) {

    $.ajax({
        type: "GET",
        url: "/pp/bomData/allbomData/" + order_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                var disableData = { 0: "", 1: "checked" }
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['pp_bom_plan_data_id'];
                    var material = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var uom = response.data.result[i]['uom'];
                    var tolerance = response.data.result[i]['tolerance'];
                    var string_id = "'" + id + "'";
                    data.push({
                        "pp_bom_plan_data_id": id,
                        "product_name": material,
                        "quantity": quantity,
                        "uom": uom,
                        "tolerance": tolerance,
                        "status": '<label class="switch ml-4"><input type="checkbox" id="' + response.data.result[i].pp_bom_plan_data_id + '" onchange="disableData(event,' + "'BomData'" + ')" ' + disableData[response.data.result[i].status] + '><span class="slider round"></span</lable>',
                        "action": '<button class="btn btn-warning mr-4 ml-2 btn-edit" data-toggle="modal" data-target="#addProductOrderModal"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button><button class="btn btn-success mr-4 btn-view" data-toggle="modal" data-target="#addProductOrderModal"><i class="fa fa-eye" aria-hidden="true"></i></button><button class="btn btn-danger" onclick="_deleted(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
                    });
                }


                var table = $('#bomDataTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}

/**
* deleted
* This function is used to delete bill of material data.
*/
function _deleted(id) {
    var table = $('#bomHeaderTable').DataTable();
    var rowData = table.row(bomHeaderSelectedIndex).data();
    $.ajax({
        type: 'DELETE',
        url: '/pp/bomData/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage("Bill of material data has been deleted successfully....")
                getBomData(rowData.pp_bom_header_id);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


/**
* updateBomData
* This function is used to update bill of material data.
* @param data This is the paramter to ajax data
*/
function updateBomData(data) {

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: '/pp/bomData/update',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Bill of material data record has been updated successfully...");

            } else {
                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {
            $('#BomDataForm').trigger("reset");
            $('#btnSaveAddBomData').text("Save");

        }

    });
}


/**
* delete
* This function is used to update settings in bill of material data.
* @param url This is the paramter to ajax request url
* @param id This is the paramter to ajax data
*/
function _disableData(id, status) {

    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: 'DELETE',
        url: '/pp/bomData/bomData/' + id,
        data: {
            _token: $('input[name=_token]').val(),
            "status": bool
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                if (status) showSuccessMessage("Data has been enabled successfully...");
                if (!status) showSuccessMessage("Data has been disabled successfully...");



            } else {
                var msg = response.data.message;
                var id = response.data.result;

                if (msg == "assigned") {
                    //assigned settings cannot be disabled
                    showWarningMessage("Settings has been assigned...!");

                } else if (msg == "error") {
                    showErrorMessage();
                }
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}



/**
* save
* This function is used to disable settings in bill of material data.
* @param event This is the paramter to identifi desable/enable
*/
function disableData(event) {
    var id = event.target.id;
    var status = event.target.checked;
    _disableData(id, status);
}




