@extends('pp::layouts.app')

@section('head')
    <!-- DataTable -->
    <link rel="stylesheet" href="{{ url('vendors/dataTable/datatables.min.css') }}" type="text/css">
    <link rel="stylesheet" href="{{ url('vendors/datepicker/daterangepicker.css') }}" type="text/css">
    <!-- Prism -->
    <link rel="stylesheet" href="{{ url('vendors/prism/prism.css') }}" type="text/css">
    <link rel="stylesheet" href="{{ Module::asset('hr:css/hr/employee.css') }}" type="text/css">
    <link rel="stylesheet" href="{{ Module::asset('hr:js/autocomplete2/css/autocomplete.min.css') }}">

    <meta name="csrf-token" content="{{ csrf_token() }}">

@endsection

@section('content')

    <div class="page-header">
        <div>
            <h3></h3>
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item">
                        <a href="#">Home</a>
                    </li>
                    <li class="breadcrumb-item">
                        <a href="#">Pages</a>
                    </li>
                    <li class="breadcrumb-item active" aria-current="page">Form Page</li>
                </ol>
            </nav>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12">
            <div class="card ">

                <div class="card-body">
                    <h6 class="card-title">Daily Collection Plan</h6>

                    <form method="POST" id="dailyPlanForm" enctype="multipart/form-data">
                        <meta name="csrf-token" content="{{ csrf_token() }}">
                        <div class="row">
                            <div class="col-md-12">

                            <div id="dailyCollectionPlan-daterangepicker" class="btn btn-outline-light">
                                <span></span>
                            </div>

                            <br><br>

                                <div class="form-row">
                                    <div class="col-md-12 mb-3">
                                        <i class="fa fa-pencil text-info" aria-hidden="true"></i>
                                        <label for="txtMaterial">Material</label>
                                        <input type="hidden" class="form-control auto-complete" id="txtProductID" name="txtProductID" placeholder="Product ID" required="" AutoComplete="off">
                                        <input class="form-control auto-complete" autocomplete="off" id="txtMaterial" name="txtMaterial" onchange="getRequired()" placeholder="" required="">
                                        <div class="valid-feedback">
                                            Looks good!
                                        </div>
                                    </div>
                                </div>


                                <div class="form-row">
                                    <div class="col-md-6 mb-3">
                                        <i class="fa fa-pencil text-info" aria-hidden="true"></i>
                                        <label for="txtSIHand">Stock In Hand</label>
                                        <input class="form-control auto-complete" id="txtSIHand" name="txtSIHand" placeholder="" required="">
                                        <div class="valid-feedback">
                                            Looks good!
                                        </div>

                                    </div>

                                    <div class="col-md-6 mb-3">
                                        <i class="fa fa-pencil text-info" aria-hidden="true"></i>
                                        <label for="txtAllocated">Allocated</label>
                                        <input class="form-control auto-complete" id="txtAllocated" name="txtAllocated" placeholder="" required="">
                                        <div class="valid-feedback">
                                            Looks good!
                                        </div>

                                    </div>
                                </div>


                                <div class="form-row">
                                    <div class="col-md-6 mb-3">
                                        <i class="fa fa-pencil text-info" aria-hidden="true"></i>
                                        <label for="txtAStock">Available Stock</label>
                                        <input class="form-control auto-complete" id="txtAStock" name="txtAStock" placeholder="" required="" >
                                        <div class="valid-feedback">
                                            Looks good!
                                        </div>

                                    </div>

                                    <div class="col-md-6 mb-3">
                                        <i class="fa fa-pencil text-info" aria-hidden="true"></i>
                                        <label for="txtRequired">Required</label>
                                        <input type="text" class="form-control" id="txtRequired" name="txtRequired" placeholder="" required="" AutoComplete="off">
                                        <div class="valid-feedback">
                                            Looks good!
                                        </div>
                                    </div>
                            </div>
                            <div>
                        </div>


                    </form>

                    <br>

                    <h6 class="card-title">Cumulative</h6>

                    <div class="row" id='rowCumulativeTable'>
                        <div class="col-md-12">
                            <div class="table-responsive">
                                <!-- Required for Responsive -->
                                <table id="cumulativeTable" class="table table-bordered datatable">
                                {{ csrf_field() }}
                                    <thead>
                                        <tr>
                                            <th class="">Date</th>
                                            <th class="">Plan(Tons)</th>
                                            <th class="">Balance</th>
                                            <th class="">Required</th>
                                            <th class="">Balance</th>
                                        </tr>
                                    </thead>
                                    <tbody>

                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                    <br>

                    <div class="form-row">
                        <div class="col-md-12 mb-3">
                            <button type="button" class="btn btn-primary" id="btnSavePlan">Save</button>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
@endsection

<!-- App scripts -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
@section('script')
    <!-- DataTable -->
    <script src="{{ url('vendors/dataTable/datatables.min.js') }}"></script>
    <script src="{{ url('assets/js/examples/datatable.js') }}"></script>
    <script src="{{ Module::asset('hr:js/autocomplete2/js/autocomplete.min.js') }}"></script>
    <!-- Javascript -->
    <script src="{{ url('vendors/datepicker/daterangepicker.js') }}"></script>
    <script src="{{ Module::asset('pp:js/dailyCollectionPlan.js') }}"></script>

    <!-- Prism -->
    <script src="{{ url('vendors/prism/prism.js') }}"></script>
@endsection
